local_station(Wagon, Station, Semaphore):-
  station(yes, _, Station, Semaphore, _, _),
  Wagon =< Station+28000,
  Wagon >= Station-28000.

visible_station(N, Station, Semaphore, Distance, big):-
  station(yes, N, Station, Semaphore, _, _),
  G_PosX =< Station+Distance,
  G_PosX+G_Xsize/G_Zoom >= Station-Distance.
visible_station(N, Station, Semaphore, Distance, small):-
  station(yes, N, Station, Semaphore, _, _),
  G_PosSmall-80000 =< Station+Distance,
  G_PosSmall+530000 >= Station-Distance.

visible_wagon(I, big):-
  G_PosX =< wagonX(I)+1000,
  G_PosX+G_Xsize/G_Zoom >= wagonX(I)-1000.
visible_wagon(I, small):-
  G_PosSmall-30000 =< wagonX(I)+1000,
  G_PosSmall+530000 >= wagonX(I)-1000.

menu_pause(press) :-
  G_Pause := 1 - G_Pause,
  modify_menu(G_Menu_Time, 1, (G_Pause =:= 1 -> checked else normal), _ ).

menu_fast_speed(press) :-
  G_FastSpeed:=(G_FastSpeed=:=1 -> 0 else 1),
  change_speed.
menu_normal_speed(press) :-
  (G_FastSpeed=\=0->
    G_FastSpeed:=0,
    change_speed
  ).
menu_slow_motion(press) :-
  G_FastSpeed:=(G_FastSpeed=:= -1 -> 0 else -1),
  change_speed.

change_speed:-
  modify_menu(G_Menu_Time, 4+G_Last_Speed, normal, _ ),
  modify_menu(G_Menu_Time, 4+G_FastSpeed, checked, _ ),
  G_Last_Speed := G_FastSpeed,
  set_main_window_text,
  Interval := (G_FastSpeed =:= 1 -> 0.01 else (G_FastSpeed =:= 0 -> 0.1 else 0.5)),
  kill_timer(_, G_Timer),
  G_Timer := set_timer(_, Interval, time_func).

set_main_window_text:-
  (G_FastSpeed=\= -1; G_Run_Invisible =:= 1 ->
    Fast:= (G_Run_Invisible =:= 1 -> " (Invisible)" else (G_FastSpeed=:=1 -> " (fast)" else "")),
    set_text("Metro "+G_Time//10+Fast, _)
  else
    Slow:= (G_Time mod 10=:=0 -> ".0" else ""),
    set_text("Metro "+G_Time/10+Slow, _)
  ).

menu_unexpected_delay(press) :-
  G_Unexpected_Delay := 1-G_Unexpected_Delay,
  modify_menu(G_Menu_Time, 7, (G_Unexpected_Delay =:= 1 -> checked else normal), _ ).

menu_different_speeds(press) :-
  G_Different_Speeds := 1-G_Different_Speeds,
  modify_menu(G_Menu_Time, 9, (G_Different_Speeds =:= 1 -> checked else normal), _ ).

menu_crazy_speed(press) :-
  G_Crazy_Speed := 3-G_Crazy_Speed,
  modify_menu(G_Menu_Time, 8, (G_Crazy_Speed =:= 2 -> checked else normal), _ ).

menu_number(press) :-
  G_MenuNumber := (G_MenuNumber-1) mod 8,
  update_window(_).
menu_minus(press) :-
  G_MenuNumber := (G_MenuNumber+1) mod 8,
  update_window(_).
menu_map_list(press) :-
  G_map_list := (G_map_list+1) mod 2,
  (G_map_list =:= 0 ->
    modify_menu(G_Menu_Show, 2, normal, "Map -> List\tL")
  else
    modify_menu(G_Menu_Show, 2, checked, "List -> Map\tL")
  ),
  update_window(_).

menu_low_heavy1(press) :-
  (G_Traffic =:= 3 ->
    G_time_period := integer(1.5*G_time_period_fast),
    G_Traffic := (G_First=\= -1, wJump(G_First)=<0 -> G_Number mod 2 else 2)
  else
    G_time_period := G_time_period_fast,
    G_Traffic := 3
  ),
  modify_menu(G_Menu_Traffic, 1, (G_Traffic =\= 3 -> checked else normal), _ ),
  update_window(_).
  
menu_low_heavy2(press) :-
  (G_Traffic2 =:= 3 ->
    G_Traffic2 := (G_First2=\= -1, wJump(G_First2)=<0 -> (G_Number2 + G_Odd_Stations) mod 2 else 2)
  else
    G_Traffic2 := 3
  ),
  modify_menu(G_Menu_Traffic, 2, (G_Traffic2 =\= 3 -> checked else normal), _ ),
  update_window(_).
  
menu_low_heavy(press) :-
  menu_low_heavy1(press),
  menu_low_heavy2(press).

make_flags_text(Text, I, 1):- !, Text := (wFlags(I)/\1=:=0-> "." else "*").
make_flags_text(Text, I, Flag):-
  NextFlag := Flag//2,
  make_flags_text(Text, I, NextFlag),
  Text := (wFlags(I)/\Flag=:=0-> ".  " else "*  ") + Text.

make_text(0, I, Text):-
  (wJump(I) > 0 ->
    Text := wJump(I)+" : "+wStop(I)
  else
    Text := "0 : "+(wJump(I)=:= -2->"Start" else (wJump(I)=:= -1 -> "A" else "B"))
  ).
make_text(1, I, Text):- Text := "#"+I+", line "+(wNumber(I)+1).
make_text(2, I, Text):- Text := "x="+wagonX(I)/100.
make_text(3, I, Text):- make_flags_text(Text, I, 64).
make_text(4, I, Text):- Text := "s="+wSpeed(I)+" + "+wAcceleration(I).
make_text(5, I, Text):- Text := "<"+wTargetSpeed(I)+", "+wTargetSpeed2(I)+">".
make_text(6, I, Text):- Text := "at "+wStopAt(I)/100+", c="+wCount(I).
make_text(7, I, Text):- 
  Text := (wPosoka(I)=:=1 -> wNext(I)+"<"+I+">"+wPrevious(I) else wPrevious(I)+"<"+I+">"+wNext(I)).

menu_zoom_in(press):- client_size(_,W,H), zoom(-1, W//2, H//2).
menu_zoom_out(press):- client_size(_,W,H), zoom(1, W//2, H//2).
menu_help(press):-
  message("Metro",
  "Metro where every wagon has its own opinion. We present a new scheme for the wagon movement which will increase the capacity of the metro tube with 17%. This will decrease the traveling time by 15% and the power consumption by 30%.

At every station is posted a scheme. At different stations the schemes are slightly different. These schemes will help to the passengers to choose the right wagon.

You can zoom in and out by the buttons + and -. You can drag the field with the mouse. Also you can move by the arrows. Other possibility to move and zoom is by the mouse wheel.",i).

menu_file(init) :-
  menu( normal, action(menu_file_open), text("&Load") ), % Open
  menu( normal, action(menu_file_open1), text("&Load (Heavy Traffic)") ),
  menu( normal, action(menu_file_open2), text("&Load (Low Traffic)") ),
  menu( normal, action(menu_file_save), text("&Save") ). % &As

menu_show(init) :-
  menu(normal, action(menu_number), text("Next Label\t<, >") ),
  menu(normal, action(menu_map_list), text("Map -> List \tL") ).

menu_time(init) :-
  menu(normal, action(menu_pause), text("&Pause\tP") ),
  menu(separator),
  menu(normal, action(menu_slow_motion), text("&Slow Motion\tS") ),
  menu(checked, action(menu_normal_speed), text("&Normal Speed")),
  menu(normal, action(menu_fast_speed), text("&Fast Speed\tF") ),
  menu(separator),
  menu(normal, action(menu_unexpected_delay), text("Unexpected Delay") ),
  menu(normal, action(menu_crazy_speed), text("Crazy Speed") ),
  menu(checked, action(menu_different_speeds), text("Different Speeds") ).

menu_traffic(init) :-
  menu(normal, action(menu_low_heavy1), text("Change Right ->") ),
  menu(normal, action(menu_low_heavy2), text("Change Left <-") ),
  menu(normal, action(menu_low_heavy), text("Change Both <- ->\tT") ).

menu_file_open(press) :-
  % F is select_file(o, _, "Metro Files (*.metro)\0*.metro\0All Files (*.*)\0*.*\0"),
  % write(F), nl,
  file_open("test.metro").

menu_file_open1(press) :-
  file_open("test1.metro").

menu_file_open2(press) :-
  file_open("test2.metro").

file_open(File):-
  H is open(File, "rb"),
  read_metro(H),
  close(H),
  (G_map_list =:= 0 ->
    modify_menu(G_Menu_Show, 2, normal, "Map -> List\tL")
  else
    modify_menu(G_Menu_Show, 2, checked, "List -> Map\tL")
  ),
  modify_menu(G_Menu_Time, 1, (G_Pause =:= 1 -> checked else normal), _ ),
  change_speed,
  modify_menu(G_Menu_Time, 7, (G_Unexpected_Delay =:= 1 -> checked else normal), _ ),
  modify_menu(G_Menu_Time, 8, (G_Crazy_Speed =:= 2 -> checked else normal), _ ),
  modify_menu(G_Menu_Time, 9, (G_Different_Speeds =:= 1 -> checked else normal), _ ),
  modify_menu(G_Menu_Traffic, 1, (G_Traffic =\= 3 -> checked else normal), _ ),
  modify_menu(G_Menu_Traffic, 2, (G_Traffic2 =\= 3 -> checked else normal), _ ),
  fix_scroll_bar_v,
  fix_scroll_bar_h.

menu_file_save(press) :-
  % kill_timer(_, G_Timer),
  % F is select_file(s, _, "Metro Files (*.metro)\0*.metro\0All Files (*.*)\0*.*\0"),
  H is open("test.metro", "wb"),
  save_metro(H),
  close(H).
  % G_Timer := set_timer(_, 0.1, time_func).

read_metro(H) :-
  G_Crazy_Speed := get(H, l),
  G_ExtraDistance := get(H, l),
  G_Wagons_in_use := get(H, l),
  G_time_period := get(H, l),
  G_Traffic := get(H, l),
  G_Traffic2 := get(H, l),
  G_First := get(H, l),
  G_First2 := get(H, l),
  G_PosX := get(H, l),
  G_PosY := get(H, l),
  G_PosSmall := get(H, l),
  G_Zoom := get(H, l)/1000,
  G_ScrollRange := get(H, l),
  G_Time := get(H, l),
  G_WagonNum := get(H, l),
  G_NextColor := get(H, l),
  G_Unexpected_Delay := get(H, l),
  G_Different_Speeds := get(H, l),
  G_Pause := get(H, l),
  G_FastSpeed := get(H, l),
  G_map_list := get(H, l),
  G_MenuNumber := get(H, l),
  G_Number := get(H, l),
  G_Number2 := get(H, l),
  G_Statistic_Course:= get(H, l),
  G_Statistic_Last:= get(H, l),
  G_Statistic_Time:= get(H, l),
  G_Statistic_averSpeed:= get(H, l),
  get_array(wagonX, H, max_wagons, 1),
  get_array(wagonY, H, max_wagons, 1),
  get_array(wPosoka, H, max_wagons, 1),
  get_array(wOldX, H, max_wagons, 1),
  get_array(wJump, H, max_wagons, 1),
  get_array(wStop, H, max_wagons, 1),
  get_array(wNumber, H, max_wagons, 1),
  get_array(wSpeed, H, max_wagons, 1000),
  get_array(wTargetSpeed, H, max_wagons, 1000),
  get_array(wTargetSpeed2, H, max_wagons, 1000),
  get_array(wStopAt, H, max_wagons, 1),
  get_array(wAcceleration, H, max_wagons, 1000),
  get_array(wCount, H, max_wagons, 1),
  get_array(wColor, H, max_wagons, 1),
  get_array(wNext, H, max_wagons, 1),
  get_array(wPrevious, H, max_wagons, 1),
  get_array(wFlags, H, max_wagons, 1),

  get_array(semaphore, H, 400, 1).

save_metro(H) :-
  put2(G_Crazy_Speed, H, l),
  put2(G_ExtraDistance, H, l),
  put2(G_Wagons_in_use, H, l),
  put2(G_time_period, H, l),
  put2(G_Traffic, H, l),
  put2(G_Traffic2, H, l),
  put2(G_First, H, l),
  put2(G_First2, H, l),
  put2(G_PosX, H, l),
  put2(G_PosY, H, l),
  put2(G_PosSmall, H, l),
  put2(1000*G_Zoom, H, l),
  put2(G_ScrollRange, H, l),
  put2(G_Time, H, l),
  put2(G_WagonNum, H, l),
  put2(G_NextColor, H, l),
  put2(G_Unexpected_Delay, H, l),
  put2(G_Different_Speeds, H, l),
  put2(G_Pause, H, l),
  put2(G_FastSpeed, H, l),
  put2(G_map_list, H, l),
  put2(G_MenuNumber, H, l),
  put2(G_Number, H, l),
  put2(G_Number2, H, l),
  put2(G_Statistic_Course, H, l),
  put2(G_Statistic_Last, H, l),
  put2(G_Statistic_Time, H, l),
  put2(G_Statistic_averSpeed, H, l),

  put_array(wagonX, H, max_wagons, 1),
  put_array(wagonY, H, max_wagons, 1),
  put_array(wPosoka, H, max_wagons, 1),
  put_array(wOldX, H, max_wagons, 1),
  put_array(wJump, H, max_wagons, 1),
  put_array(wStop, H, max_wagons, 1),
  put_array(wNumber, H, max_wagons, 1),
  put_array(wSpeed, H, max_wagons, 1000),
  put_array(wTargetSpeed, H, max_wagons, 1000),
  put_array(wTargetSpeed2, H, max_wagons, 1000),
  put_array(wStopAt, H, max_wagons, 1),
  put_array(wAcceleration, H, max_wagons, 1000),
  put_array(wCount, H, max_wagons, 1),
  put_array(wColor, H, max_wagons, 1),
  put_array(wNext, H, max_wagons, 1),
  put_array(wPrevious, H, max_wagons, 1),
  put_array(wFlags, H, max_wagons, 1),

  put_array(semaphore, H, 400, 1).

*** put2(int W, obj(H), T) :- 47.

get_array(Array, H, Size, D):-
  for(I, 0, Size),
  Array(I) := get(H, l)/D,
  fail.
get_array(_, _, _, _).

put_array(Array, H, Size, D):-
  for(I, 0, Size),
  put2(D*Array(I), H, l),
  fail.
put_array(_, _, _, _).

my_paint(PosX, PosY, ZoomX, ZoomY, small):-
  pen(0, 0),
  brush(rgb(0, 180, 180)),
  rect(0, 0, G_Xsize+10, 100),
  pen(1, 0),
  X1 := (G_PosX-PosX)*ZoomX,
  X2 := (G_PosX-PosX+G_Xsize/G_Zoom)*ZoomX,
  Y1 := (G_PosY-PosY+100/G_Zoom)*ZoomY,
  Y2 := (G_PosY-PosY+G_Ysize/G_Zoom)*ZoomY,
  line(X1, Y1, X1, Y2, X2, Y2, X2, Y1, X1, Y1),
  fail.

my_paint(PosX, PosY, ZoomX, ZoomY, Variant):-
  ZoomY>=0.02,
  (ZoomX>0.08->
    pen(1+10*ZoomX, rgb(255, 0, 0)),
    Add:=72
  else
    pen(1+2*10*ZoomX, rgb(255, 0, 0)),
    Add:=0
  ),
  get_metro_line(X1, Y1, X2, Y2, Sem1, Sem2, Variant),
  X1p := (Sem1\=no, semaphore(Sem1)=:=1 -> X1+1200 else X1),
  X2p := (Sem2\=no, semaphore(Sem2)=:=1 -> X2-1200 else X2),
  line((X1p-PosX)*ZoomX, (Y1+Add-PosY)*ZoomY, (X2p-PosX)*ZoomX, (Y2+Add-PosY)*ZoomY),
  put_grid(X2, Y2, X1, Y1, PosX, PosY, ZoomX, ZoomY, Variant),
  (ZoomX>0.08->
    line((X1p-PosX)*ZoomX, (Y1-Add-PosY)*ZoomY, (X2p-PosX)*ZoomX, (Y2-Add-PosY)*ZoomY)
  ),
  fail.

my_paint(PosX, PosY, ZoomX, ZoomY, Variant):-
  ZoomY>=0.02,
  (ZoomX>0.08->
    Add:=72
  else
    Add:=0
  ),
  get_visible_arc(X, Y, Sign, Q1, Q2, Semaphore),
  D := (Q2-Y)+(Q1-X)**2/(Q2-Y),
  % write(" R="+D/2), nl,
  (Sign*X>Sign*Q1 -> Y := Y+30, Q2 := Q2 + 10), % +10, +30 for beauty
  (Semaphore\=no, semaphore(Semaphore)=:=0 ->
    Open := (X>Q1 -> -1200 else 1200)
  else
    Open := 0
  ),
  my_draw_arc(X, Y+Add, D, Q1, Q2+Add, Open, Sign, PosX, PosY, ZoomX, ZoomY, Variant),
  (ZoomX>0.08->
    my_draw_arc(X, Y-Add, D, Q1, Q2-Add, Open, Sign, PosX, PosY, ZoomX, ZoomY, Variant)
  ),
  fail.

my_paint(PosX, PosY, ZoomX, ZoomY, Variant):-
  ZoomY>=0.01,
  make_station(1, PosX, PosY, ZoomX, ZoomY, Variant).
my_paint(PosX, PosY, ZoomX, ZoomY, Variant):-
  ZoomY>=0.01,
  make_station(-1, PosX, PosY, ZoomX, ZoomY, Variant).

my_paint(PosX, PosY, ZoomX, ZoomY, Variant):-
  font(10,25,_),
  pen(10*ZoomX, 0),
  for(I, 0, G_WagonNum-1),
  visible_wagon(I, Variant),
  brush(wColor(I)),
  X := (wagonX(I)-PosX)*ZoomX,
  Y := (wagonY(I)-PosY)*ZoomY,
  (in_curve(I, Xc, Yc, Sign, R)->
    Alfa := arccos((wagonX(I)-Xc)/R),
    Cx := (sin(Alfa)*1000-wPosoka(I)*Sign*cos(Alfa)*150)*ZoomX,
    Cy := (sin(Alfa)*150+wPosoka(I)*Sign*cos(Alfa)*1000)*ZoomY,
    Cx2 := (sin(Alfa)*1000+wPosoka(I)*Sign*cos(Alfa)*150)*ZoomX,
    Cy2 := (sin(Alfa)*150-wPosoka(I)*Sign*cos(Alfa)*1000)*ZoomY,
    fill_polygon( X - Cx, Y - Cy, X - Cx2, Y + Cy2, X + Cx, Y + Cy, X + Cx2, Y - Cy2)
  else
    SizeX := 1000*ZoomX,
    SizeY := 150*ZoomY,
    (wFlags(I)/\4=:=0->
      rect(X - SizeX, Y - SizeY, X + SizeX, Y + SizeY)
    else (wPosoka(I)=:=1->
      rect(X - SizeX, Y - SizeY, X + SizeX, Y + SizeY+120*ZoomY)
    else
      rect(X - SizeX, Y - SizeY - 120*ZoomY, X + SizeX, Y + SizeY)
    ))
  ),
  (Variant=big, ZoomX>0.08->
    make_text(G_MenuNumber, I, Text),
    text_out(Text, pos(X-25, Y-10))
  ),
  fail.

my_paint(PosX, PosY, ZoomX, ZoomY, Variant):-
  font(ZoomY*300,ZoomY*750,_),
  visible_station(N, Station, _, 8000, Variant),
  station(yes, N, Station, _, Text, Text2),
  X := Station-2000,
  Y := -500,
  text_out(N+". "+Text+" "+Text2, pos((X-PosX)*ZoomX-5, (Y-PosY)*ZoomY-10)),
  fail.

my_paint(PosX, PosY, ZoomX, ZoomY, big):-
  G_Zoom>0.08,
  font(10,25,_),
  visible_station(N, Station, _, 8000, big),
  init_wagon_arrive,
  First := G_First,
  (find_wagon_arrive(First, _, Station, 1); true),
  calc_when(Station, 1),
  which_line(N, 1),
  draw_data(Station),
  Max := max(wagon_time(10), wagon_time(11)),
  (wagon_time(12)< Max ->
    Number := (wagon_arrive(12) =\= -1 -> wNumber(wagon_arrive(12)) else (G_Number+1) mod 10),
    Point := (N - finish_station(-1) + Number) mod 10,
    make_platform(Point, Platform)
  else
    Platform = 4
  ),
  draw_when(Station, Max, Platform),
  (G_map_list=:=0 ->
    make_map(N, Station)
  else
    make_list(N, Station, Max, Platform)
  ).

make_map(N, Station):-
  pen(10*G_Zoom, 0),
  make_brush(12),
  X := Station-1500,
  Y := 2870,
  Rx := 200,
  Ry := 550,
  ellipse((X+Rx-G_PosX)*G_Zoom, (Y+Ry-G_PosY)*G_Zoom, (X-Rx-G_PosX)*G_Zoom, (Y-Ry-G_PosY)*G_Zoom),
  pen(20*G_Zoom, rgb(0, 0, 255)),
  Y0:=2500,
  Y := 3250,
  Y1 := 4000,
  X1 := Station-5500,
  X2 := Station,
  line((X1-G_PosX)*G_Zoom, (Y0-G_PosY)*G_Zoom, (X2+500-G_PosX)*G_Zoom, (Y0-G_PosY)*G_Zoom),
  line((X1-G_PosX)*G_Zoom, (Y-G_PosY)*G_Zoom, (X2-4500-G_PosX)*G_Zoom, (Y-G_PosY)*G_Zoom),
  D:=750,
  draw_arc((X1-D/2-G_PosX)*G_Zoom, (Y0-G_PosY)*G_Zoom, (X1+D/2-G_PosX)*G_Zoom, (Y0+D-G_PosY)*G_Zoom, (X1-G_PosX)*G_Zoom, (Y0-G_PosY)*G_Zoom, (X1-G_PosX)*G_Zoom, (Y-G_PosY)*G_Zoom),
  pen(20*G_Zoom, rgb(255, 0, 0)),
  X1 := Station-4500,
  X2 := Station+4500,
  line((X1-G_PosX)*G_Zoom, (Y-G_PosY)*G_Zoom, (X2-G_PosX)*G_Zoom, (Y-G_PosY)*G_Zoom),
  X1 := Station+2250,
  X2 := Station+1500,
  line((X1-G_PosX)*G_Zoom, (Y1-G_PosY)*G_Zoom, (X2-G_PosX)*G_Zoom, (Y-G_PosY)*G_Zoom),
  X2 := Station+3250,
  line((X1-G_PosX)*G_Zoom, (Y1-G_PosY)*G_Zoom, (X2-G_PosX)*G_Zoom, (Y1-G_PosY)*G_Zoom),
  pen(10*G_Zoom, 0),
  Add :=5500, Y:=2500, Sign:= -1,
  for(I, 1, 35),
  (I=:=14-> Y :=3250, Add := -7000, Sign:=1),
  (I=:=33-> Y :=4000, Add := -9750),
  R := (I=:=N -> 200 else 100),
  N1 := (32<N -> N-6 else N),
  (I<N->
    Brush := -1
  else (I<26->
    Brush := (N=:=I -> 0 else 1+(abs(N1-I)-1) mod 10)
  else (I<33->
    Brush := (N=:=I -> 0 else 1+(abs(N-I)-1) mod 10) % ; 32<N
  else
    Brush := (N=:=I -> 0 else (26<N, N<33 -> -1 else 1+(abs(N1-I+6)-1) mod 10))
  ))),
  X := Station-4500 + Sign*I*500+Add,
  more_variants(X, Y, R, Brush),
  (G_Zoom>0.2->
    text_out(I, pos((X-G_PosX)*G_Zoom-5, (Y-G_PosY)*G_Zoom-10)),
    station(_, I, _, _, Text, Text2),
    text_out(Text, pos((X-150-G_PosX)*G_Zoom-5, (Y+300-G_PosY)*G_Zoom-10)),
    text_out(Text2, pos((X-150-G_PosX)*G_Zoom-5, (Y+300-G_PosY)*G_Zoom+15))
  ),
  fail.

more_variants(X, Y, R, Brush):-
  (Brush=:=3 -> (wagon_time(arrive_line(0))>wagon_time(arrive_line(3))-> Brushes=[3, 1] else Brushes=[1, 3])
  else (Brush=:=5 -> (wagon_time(arrive_line(2))>wagon_time(arrive_line(1))-> Brushes=[2, 4] else Brushes=[4, 2])
  else (Brush=:=7 -> (wagon_time(arrive_line(0))>wagon_time(arrive_line(1))-> Brushes=[3, 4] else Brushes=[4, 3])
  else (Brush=:=10 ->
    smaller(Smaller, 0, 1),
    smaller(Smaller2, Smaller, 2),
    smaller(Smaller3, Smaller2, 3),
    final_brush(Smaller3, Brushes)
  else (Brush>4 ->
    convert_brush(Brush, NewBrush), Brushes=[NewBrush]
  else
    Brushes=[Brush]
  ))))),
  Flags := 0,
  (Brush>0 ->
    Min := min(wagon_time(10), wagon_time(11)),
    Max := max(wagon_time(10), wagon_time(11)),
    prepare_List(0, Flags, Min, Max, Brushes, NewBrushes)
  else
    Brushes = NewBrushes
  ),
  (Flags /\ 1 =:= 0 ->
    Brushes2=NewBrushes
  else (Flags /\ 2 =:= 0 ->
    Brushes2=[0|NewBrushes]
  else
    append(NewBrushes, [0], Brushes2)
  )),
  I := list_length(Brushes2)-1,
  Y1:=Y-60*I,
  R1:=R-10*I,
  draw_ellipse(X, Y1, R1, Brushes2).

prepare_List(I, Flags, Min, Max, Brushes, NewBrushes):-
  (I<4 ->
    Time := wagon_time(arrive_line(I)),
    (choose_action(I, Time, Max)->
      % (I =:= Platform, Time>wagon_time(12); I mod 2 =:= 0),
      make_jump(I, I0),
      remove_el(I0, Brushes, Brushes2),
      Flags := Flags \/ 1
    else
      (Time > Min -> Flags := Flags \/ 2),
      Brushes = Brushes2
    ),
    I2 := I+1,
    prepare_List(I2, Flags,  Min, Max, Brushes2, NewBrushes)
  else
    Brushes = NewBrushes
  ).

remove_el(El, [], []).
remove_el(El,[El|T],T):- !.
remove_el(El,[H|L],[H|T]):-
  remove_el(El,L,T).

final_brush(0, [2, 1, 4, 3]).
final_brush(1, [3, 2, 1, 4]).
final_brush(2, [1, 4, 3, 2]).
final_brush(3, [4, 3, 2, 1]).

smaller(Smaller, I, J):- (wagon_time(arrive_line(I))>wagon_time(arrive_line(J))-> Smaller=J else Smaller=I).

draw_ellipse(X, Y, R, [Brush|Tail]):-
  make_brush(Brush),
  ellipse((X+R-G_PosX)*G_Zoom, (Y+R-G_PosY)*G_Zoom, (X-R-G_PosX)*G_Zoom, (Y-R-G_PosY)*G_Zoom),
  Y1:=Y+60,
  R1:=R+10,
  draw_ellipse(X, Y1, R1, Tail).
draw_ellipse(_, _, _, []).

make_list(N, Station, Max, Platform):-
  font(G_Zoom*90,G_Zoom*225,_),
  Finish := finish_station(1),
  for(I, 0, 3),
    X := Station+G_ExtraDistance+(I-2)*(2000+G_ExtraDistance),
    Time := wagon_time(arrive_line(I)),
    (I =:= Platform, Time>wagon_time(12) ->
      Step := I
    else
      (choose_action(I, Time, Max)->
        I mod 2 =:= 0,
        Step := (Platform=:=4 -> 2*true_value(wagon_time(10)>wagon_time(11)) else Platform)
      else
        Step := 10
      )
    ),
    make_jump(I, Jump),
    make_list2(Step, N, N, Finish, Jump, Jump, X, 2050).

make_list2(Step, N0, N, Finish, Jump0, Jump, X, Y):-
  N2 := (Step=\=10 -> N+1 else N+Jump),
  N2 =< Finish,
  Brush:= (N2-N0) mod 10,
  Jump2 := 1 + Jump mod 4,
  Y2 := Y+300,
  station(_, N2, _, _, Text, Text2),
  (Step=\=10 ->
    make_jump(Step, Arrive)
  else (Brush=:=3 -> (wagon_time(arrive_line(0))>wagon_time(arrive_line(3))-> Arrive= 1 else Arrive= 3)
  else (Brush=:=5 -> (wagon_time(arrive_line(2))>wagon_time(arrive_line(1))-> Arrive= 4 else Arrive= 2)
  else (Brush=:=7 -> (wagon_time(arrive_line(0))>wagon_time(arrive_line(1))-> Arrive= 4 else Arrive= 3)
  else (Brush=:=0 ->
    smaller(Smaller, 0, 1),
    smaller(Smaller2, Smaller, 2),
    smaller(Smaller3, Smaller2, 3),
    make_jump(Smaller3, Arrive)
  else
    Arrive=Jump0
  ))))),
  (Arrive=\=Jump0-> color_text(_, rgb(160, 160, 255)) ),
  text_out((N2-N0)+" "+Text+" "+Text2+" ", pos((X+200-G_PosX)*G_Zoom-5, (Y2-G_PosY)*G_Zoom-10)),
  (Arrive=\=Jump0->
    R:= 100,
    direction(Jump0, Arrive, Dir),
    (Step=\=10 -> make_brush(0) else make_brush(Arrive)),
    % (Arrive=\=Jump0 -> make_brush(Arrive) else make_brush(0)),
    fill_polygon((X+Dir*R-G_PosX)*G_Zoom, (Y2+25+R-G_PosY)*G_Zoom, (X-Dir*R-G_PosX)*G_Zoom, (Y2+25-G_PosY)*G_Zoom, (X+Dir*R-G_PosX)*G_Zoom, (Y2+25-R-G_PosY)*G_Zoom),
    color_text(_, rgb(0, 0, 0))
  ),
  make_list2(Step, N0, N2, Finish, Jump0, Jump2, X, Y2).

direction(3, _, -1).
direction(4, 4, -1).
direction(4, 1, -1).
direction(4, 2, -1).
direction(4, 3,  1).
direction(2, 1, -1).
direction(2, 3,  1).
direction(2, 4,  1).
direction(2, 2, -1).
direction(1, 1, -1).
direction(1, 2,  1).
direction(1, 3,  1).
direction(1, 4,  1).

make_jump(0, 3).
make_jump(1, 4).
make_jump(2, 2).
make_jump(3, 1).

init_wagon_arrive:-
  for(I, 0, 12),
  wagon_arrive(I):= -1,
  fail.
init_wagon_arrive.

find_wagon_arrive(First, SureFirst, Station, Posoka):-
  First =\= -1,
  Posoka*(Station+Posoka*(4000+2*G_ExtraDistance)-wagonX(First)) > 0,
  BeforeStation := true_value(Posoka*(Station-Posoka*(4000+2*G_ExtraDistance)-wagonX(First)) > 0),
  (BeforeStation=:=1; wStop(First)=:=0 ->
    (wJump(First)>0->
      wagon_arrive(wNumber(First)):= First
    else
      wagon_arrive(10-wJump(First)):= First
    ),
    (BeforeStation=:=1 -> SureFirst := wPrevious(First))
  ),
  First := wPrevious(First),
  find_wagon_arrive(First, SureFirst, Station, Posoka).

calc_when(Station, Posoka):-
  Where := finish_station(-1*Posoka),
  station(yes, Where, S, _, _, _),
  StartPoint := S - Posoka*20000,
  (Posoka=:=1 ->
    (G_First =\= -1 -> StartPoint := min(wagonX(G_First), StartPoint)),
    Traffic := G_Traffic,
    Number := G_Number
  else
    (G_First2 =\= -1 -> StartPoint := max(wagonX(G_First2), StartPoint)),
    Traffic := G_Traffic2,
    Number := G_Number2
  ),
  for(I, 0, 12),
  (wagon_arrive(I)=:= -1 ->
    (I > 9 ->
      (Traffic =:= 3; (I =:= 12, Traffic < 2) ->
        Periods := 11
      else
        Periods := (((I-Traffic-1) mod 3)+1)
      )
    else
      (Traffic =:= 3 ->
        Periods := (((I-Number-1) mod 10)+1)
      else
        Periods := 11
      )
    ),
    wagon_time(I):= Periods*G_time_period + abs(Station - StartPoint)/G_Statistic_averSpeed
  else (wFlags(wagon_arrive(I))/\4=\=0, Posoka*(Station-Posoka*(4000+2*G_ExtraDistance)-wagonX(wagon_arrive(I))) < 0 ->
    wagon_time(I):= 0
  else
    wagon_time(I):= abs(Station+Posoka*(4000+2*G_ExtraDistance) - wagonX(wagon_arrive(I)))/G_Statistic_averSpeed
  )),
  fail.
calc_when(_, _).

make_line(0, 2).
make_line(1, 5).
make_line(2, 0).
make_line(3, 9).

which_line(N, Posoka):-
  for(I, 0, 3),
  make_line(I, Line),
  arrive_line(I):=(Line + Posoka*(finish_station(-1*Posoka) - N)) mod 10,
  fail.
which_line(_, _).

map_list(0, "Map").
map_list(1, "List").

draw_data(Station):-
  X := Station-2000-2*(2000+G_ExtraDistance),
  Text:= (G_Traffic =:= 3 -> "Heavy" else "Low")+" ->, "+(G_Traffic2 =:= 3 -> "Heavy" else "Low")+" <-",
  text_out(Text, pos((X-G_PosX)*G_Zoom-5, (1950-G_PosY)*G_Zoom-10)),
  map_list(G_map_list, Text2),
  text_out(Text2, pos((X-G_PosX)*G_Zoom-5, (2350-G_PosY)*G_Zoom-10)),
  (G_Unexpected_Delay =:= 1 ->
    text_out("Un.D.", pos((X-G_PosX)*G_Zoom-5, (2750-G_PosY)*G_Zoom-10))
  ),
  (G_Crazy_Speed =:= 2 ->
    text_out("Cr.Sp.", pos((X-G_PosX)*G_Zoom-5, (3150-G_PosY)*G_Zoom-10))
  ),
  (G_Different_Speeds =:= 0 ->
    text_out("Equal Speeds", pos((X-G_PosX)*G_Zoom-5, (3550-G_PosY)*G_Zoom-10))
  ).

draw_when(Station, Max, Platform):-
  font(G_Zoom*110,G_Zoom*275,_),
  color_text_back(_, rgb(0, 0, 127)), 
  for(I, 0, 3),
    X := Station+500+(I-2)*(2000+G_ExtraDistance),
    Time := wagon_time(arrive_line(I)),
    (I =:= Platform, Time>wagon_time(12) ->
      Time := wagon_time(12),
      color_text(_, rgb(255, 0, 0))
    else
      (choose_action(I, Time, Max)->
        I mod 2 =:= 0,
        % wagon_time(arrive_line(I)):= Time+1,
        color_text(_, rgb(255, 255, 255))
      else
        color_text(_, rgb(255, 255, 0))
      )
    ),
    text_out(" After "+round(Time/600)+" min ", pos((X-G_PosX)*G_Zoom-5, (1950-G_PosY)*G_Zoom-10)),
    % text_out(" After: "+Time//10+" s ", pos((X-G_PosX)*G_Zoom-5, (1950-G_PosY)*G_Zoom-10)),
    % text_out(" At: "+(G_Time+Time)//10+" ", pos((X-G_PosX)*G_Zoom-5, (1950-G_PosY)*G_Zoom-10)),
    fail.
draw_when(_, _, _):-
  font(10,25,_),
  color_text(_, rgb(0, 0, 0)), 
  color_text_back(_, rgb(255, 255, 255)).

choose_action(0, Time, Max):- Time>wagon_time(10), Time := wagon_time(10).
choose_action(1, Time, Max):- Time>Max.
choose_action(2, Time, Max):- Time>wagon_time(11), Time := wagon_time(11).
choose_action(3, Time, Max):- Time>Max.

choose_pen(0, ZoomY):- pen(4+80*ZoomY, rgb(255, 255, 0)).
choose_pen(1, ZoomY):- pen(4+80*ZoomY, rgb(255, 0, 0)).
choose_pen(2, ZoomY):- pen(4+80*ZoomY, rgb(0, 0, 255)).
choose_pen(3, ZoomY):- pen(4+80*ZoomY, rgb(0, 127, 0)).
choose_pen(4, ZoomY):- pen(4+80*ZoomY, rgb(255, 255, 255)).

make_station(Posoka, PosX, PosY, ZoomX, ZoomY, Variant):-
  SureFirst := (Posoka=:=1 -> G_First else G_First2),
  Number := (Posoka=:=1 -> G_Number else G_Number2),
  init_wagon_arrive,
  for(N, finish_station(-1*Posoka), finish_station(Posoka), step(Posoka)),
  visible_station(N, Station, _, 4000, Variant),
  First := SureFirst,
  (find_wagon_arrive(First, SureFirst, Station, Posoka); true),
  calc_when(Station, Posoka),
  which_line(N, Posoka),
  Max := max(wagon_time(10), wagon_time(11)),
  (wagon_time(12)< Max ->
    Number2 := (wagon_arrive(12) =\= -1 -> wNumber(wagon_arrive(12)) else (Number+1) mod 10),
    Point := (Posoka*(N - finish_station(-1*Posoka)) + Number2) mod 10,
    make_platform(Point, Platform)
  else
    Platform = 4
  ),
  for(I, 0, 3),
  Time := wagon_time(arrive_line(I)),
  (choose_action(I, Time, Max)->
    (I =:= Platform, Time>wagon_time(12); I mod 2 =:= 0),
    choose_pen(4, ZoomY)
  else
    choose_pen(I, ZoomY)
  ),
  X1 := Station-Posoka*(4000+1.5*G_ExtraDistance-I*(2000+G_ExtraDistance)),
  Y := 1250+Posoka*500,
  X2 := X1+Posoka*2000,
  line((X1-PosX)*ZoomX, (Y-PosY)*ZoomY, (X2-PosX)*ZoomX, (Y-PosY)*ZoomY),
  fail.

win_func(paint):-
  G_Run_Invisible =:= 0,
  (my_paint(G_PosX, G_PosY, G_Zoom, G_Zoom, big)
  ;
  ZoomX := 0.0034*G_Xsize/1863,
  my_paint(-25000+G_PosSmall, -2000, ZoomX, 0.02, small)).

win_func(init):-
  menu( pop_up, action(menu_file), text("&File") ),
  G_Menu_Show := menu( pop_up, action(menu_show), text("&Show") ),
  G_Menu_Time := menu( pop_up, action(menu_time), text("&Time") ),
  G_Menu_Traffic := menu( pop_up, action(menu_traffic), text("Traffic") ),
  menu(right, action(menu_zoom_in), text("Zoom &In") ),
  menu(right, action(menu_zoom_out), text("Zoom &Out") ),
  menu( right, action(menu_help), text("&Help") ),
  G_Timer := set_timer(_, 0.1, time_func),
  set_scroll_range(_,vertical,0,G_ScrollRange),
  set_scroll_range(_,horizontal,0,G_ScrollRange),
  fix_scroll_bar_v,
  fix_scroll_bar_h.

%win_func(key_down(Ch, Rep)):-
%  write(Ch), nl,
%  fail.

win_func(key_down(73, Rep)):- % I
  G_Run_Invisible := 1 - G_Run_Invisible, update_window(_). 
win_func(key_down(84, Rep)):- % T
  menu_low_heavy(press). 
win_func(key_down(83, Rep)):- % S
  menu_slow_motion(press). 
win_func(key_down(70, Rep)):- % F
  menu_fast_speed(press). 
win_func(key_down(80, Rep)):- % P
  menu_pause(press).
win_func(key_down(190, Rep)):- % >
  menu_minus(press).
win_func(key_down(188, Rep)):- % <
  menu_number(press).
win_func(key_down(76, Rep)):- % L
  menu_map_list(press). 
win_func(key_down(187, Rep)):- % +
  menu_zoom_in(press).
win_func(key_down(189, Rep)):- % -
  menu_zoom_out(press).
 
win_func(key_down(36, Rep)):- % home
  G_PosSmall := 0, fix_scroll_bar_h.
win_func(key_down(35, Rep)):- % end
  G_PosSmall := end_map, fix_scroll_bar_h.
win_func(key_down(45, Rep)):- % insert <- slow
  G_PosSmall := max(0, G_PosSmall-Rep*10000), fix_scroll_bar_h.
win_func(key_down(33, Rep)):- % page Up -> slow
  G_PosSmall := min(end_map, G_PosSmall+Rep*10000), fix_scroll_bar_h.
win_func(key_down(46, Rep)):- % del <- fast
  G_PosSmall := max(0, G_PosSmall-Rep*50000), fix_scroll_bar_h.
win_func(key_down(34, Rep)):- % page Down -> fast
  G_PosSmall := min(end_map, G_PosSmall+Rep*50000), fix_scroll_bar_h.

win_func(key_down(Char, Rep)):-
  Xold:=G_PosX,
  Yold:=G_PosY,
  (Char=37-> % left
    G_PosX:= G_PosX - G_Xsize*0.02*Rep/G_Zoom
  ),
  (Char=39-> % right
    G_PosX:= G_PosX + G_Xsize*0.02*Rep/G_Zoom
  ),
  (Char=38-> % up
    G_PosY:= G_PosY - G_Ysize*0.02*Rep/G_Zoom
  ),
  (Char=40-> % down
    G_PosY:= G_PosY + G_Ysize*0.02*Rep/G_Zoom
  ),
  move(Xold, Yold).

win_func(size(X,Y)):-
  G_Xsize:=X,
  G_Ysize:=Y,
  update_window(_).

win_func(mouse_click(X, Y)):-
  ZoomX := 0.0034*G_Xsize/1863,
  (Y<100->
    G_Variant:= small,
    Xold:=G_PosX,
    Yold:=G_PosY,
    ZoomY:= 0.02,
    G_PosX:= -25000+G_PosSmall+X/ZoomX-0.5*G_Xsize/G_Zoom,
    G_PosY:= -2000+Y/ZoomY-100/G_Zoom-0.25*(G_Ysize-100)/G_Zoom,
    move(Xold, Yold)
  else
    G_Variant:= big,
    (G_map_list =:= 0, G_Zoom>0.08 ->
      X1 := G_PosX + 6250 + X/G_Zoom,
      Y1 := G_PosY + 3125 + Y/G_Zoom,
      ((375 - Y1 mod 750)**2 + (250 - X1 mod 500)**2 < 10000 ->
        visible_station(N, Station, _, 8000, big),
        Y0 := Y1// 750 - 7, 0=<Y0, Y0<2,
        N2 := (X1 - Station)// 500 + 11,
        (Y0 =:= 0 -> N2 := 25-N2),
        (station(yes, N2, Station2, _, _, _) ->
          Xold:=G_PosX,
          Yold:=G_PosY,
          G_PosX:= G_PosX + Station2 - Station,
          G_PosSmall:= 25000+ G_PosX-X/ZoomX+0.5*G_Xsize/G_Zoom,
          (G_PosSmall<0 -> G_PosSmall := 0),
          (G_PosSmall>end_map -> G_PosSmall := end_map),
          fix_scroll_bar_h,
          move(Xold, Yold)
        )
      )
    )
  ),
  G_moveX:=X,
  G_moveY:=Y,
  set_capture(_).

win_func(mouse_click_up(X, Y)):-
  release_capture.

win_func(mouse_move(X, Y)):-
  (message_flags(left)->
    Xold:=G_PosX,
    Yold:=G_PosY,
    (G_Variant=big->
      ZoomX:=G_Zoom,
      ZoomY:=G_Zoom
    else
      ZoomX := -0.0034*G_Xsize/1863,
      ZoomY:= -0.02
    ),
    G_PosX:= G_PosX + (G_moveX-X)/ZoomX,
    G_PosY:= G_PosY + (G_moveY-Y)/ZoomY,
    move(Xold, Yold),
    G_moveX:=X,
    G_moveY:=Y
  ).

win_func(scroll(horizontal,Type,Val)):-
  (Type=line->
    Step := 10000
  else (Type=page->
    Step := 100000
  else (Type=thumb_track->
    Step := (end_map+500000)/G_ScrollRange,
    Old := Val,
    Val := Val - G_Scroll_h,
    G_Scroll_h := Old
  else % thumb_moved_to
    G_Scroll_h := G_ScrollRange*(G_PosSmall/(end_map+500000)),
    fail
  ))),
  G_PosSmall := G_PosSmall + Step*Val,
  (G_PosSmall<0 -> G_PosSmall := 0),
  (G_PosSmall>end_map -> G_PosSmall := end_map),
  fix_scroll_bar_h.

win_func(scroll(vertical,Type,Val)):-
  Xold:=G_PosX,
  Yold:=G_PosY,
  (Type=line->
    Step := 0.02
  else (Type=page->
    Step := 0.3
  else (Type=thumb_track->
    Step := 0.02,
    Old := Val,
    Val := Val - G_Scroll_v,
    G_Scroll_v := Old
  else % thumb_moved_to
    G_Scroll_v := (G_ScrollRange-G_ScrollPage)//2,
    fail
  ))),
  G_PosY:= G_PosY + G_Ysize*Step*Val/G_Zoom,
  move(Xold, Yold).

win_func(mouse_wheel(Delta, X, Y)):-
  (message_flags(left); message_flags(middle); message_flags(ctrl)->
    client_pos(_,A,B),
    zoom(0-Delta, X-A, Y-B)
  else
    Yold:=G_PosY,
    G_PosY:= G_PosY - 3*G_Ysize*0.02*Delta/G_Zoom,
    move(G_PosX, Yold)
  ).

win_func(r_mouse_click(X, Y)):-
  (message_flags(ctrl)->
    zoom( 7, X, Y)
  else
    zoom(-7, X, Y)
  ). 

zoom(Delta, X, Y):-
  G_Zoom:=G_Zoom*0.9**Delta,
  G_PosX:= G_PosX - X* (1 - 0.9**Delta)/G_Zoom,
  G_PosY:= G_PosY - Y* (1 - 0.9**Delta)/G_Zoom,
  fix_scroll_bar_v,
  update_window(_).

fix_scroll_bar_v:-
  G_ScrollPage := (G_Zoom=<0.25 -> 1000*G_Zoom else 1500+1000*log(G_Zoom)/log(0.25)),
  G_Scroll_v := (G_ScrollRange-G_ScrollPage)//2,
  set_scroll_page(_,vertical,G_ScrollPage),
  set_scroll_pos(_,vertical,G_Scroll_v).

fix_scroll_bar_h:-
  G_Scroll_h := G_ScrollRange*(G_PosSmall/(end_map+500000)),
  set_scroll_page(_,horizontal,G_ScrollRange*500000/(end_map+500000)),
  set_scroll_pos(_,horizontal,G_Scroll_h),
  update_window(_).

move(Xold, Yold):-
  update_window(_).
  %scroll_window(_, floor(Xold*G_Zoom)-floor(G_PosX*G_Zoom), floor(Yold*G_Zoom)-floor(G_PosY*G_Zoom), 1).

put_grid(X2, Y2, X1, Y1, PosX, PosY, ZoomX, ZoomY, big):-
  (X1<X2-> A:=X1, B:=X2 else A:=X2, B:=X1),
  for(X, A, B, step(5000)),
  line((X-PosX)*ZoomX, (Y1-72-PosY)*ZoomY, (X-PosX)*ZoomX, (Y1+72-PosY)*ZoomY),
  fail.
put_grid(X2, Y2, X1, Y1, PosX, PosY, ZoomX, ZoomY, Variant).

get_local_arc(Wagon, X, Y, Sign, Q1, Q2, R, Semaphore):-
  metro_arc(X, Y, Sign, Q1, Q2, R, Semaphore).
get_local_arc(Wagon, X+Point, Y, Sign, Q1+Point, Q2, R, Semaphore2):-
  local_station(Wagon, Point, FirstSemaphore),
  local_metro_arc(X, Y, Sign, Q1, Q2, R, Semaphore),
  Semaphore2 := (Semaphore=no-> no else Semaphore+FirstSemaphore).

get_visible_arc(X, Y, Sign, Q1, Q2, Semaphore):-
  metro_arc(X, Y, Sign, Q1, Q2, _, Semaphore).
get_visible_arc(X+Point, Y, Sign, Q1+Point, Q2, Semaphore2):-
  visible_station(_, Point, FirstSemaphore, 20000, big),
  local_metro_arc(X, Y, Sign, Q1, Q2, _, Semaphore),
  Semaphore2 := (Semaphore=no-> no else Semaphore+FirstSemaphore).

get_metro_line(X1, Y1, X2, Y2, Sem1, Sem2, Variant):-
  metro_line(X1, Y1, X2, Y2, Sem1, Sem2).
get_metro_line(X1+Point, Y1, X2+Point, Y2, NewSem1, NewSem2, Variant):-
  visible_station(_, Point, FirstSemaphore, 20000, Variant),
  local_metro_line(X1, Y1, X2, Y2, Sem1, Sem2),
  NewSem1 := (Sem1=no-> no else Sem1+FirstSemaphore),
  NewSem2 := (Sem2=no-> no else Sem2+FirstSemaphore).
get_metro_line(X1+5000, Y, X2-5000, Y, no, no, Variant):-
  visible_station(Where, X1, _, 300000, Variant), % increase if distance between stations is more than 3 km 
  NextSt := Where+1,
  station(yes, NextSt, X2, _, _, _),
  (Y=1010; Y=1520).

my_draw_arc(X, Y, D, Q1, Q2, Open, Sign, PosX, PosY, ZoomX, ZoomY, Variant):-
  (Sign=:=1->
    draw_arc((X-D/2-PosX)*ZoomX, (Y-PosY)*ZoomY, (X+D/2-PosX)*ZoomX, (Y+D-PosY)*ZoomY, (Q1-PosX)*ZoomX, (Q2-PosY)*ZoomY, (X+Open-PosX)*ZoomX, (Y-PosY)*ZoomY)
  else
    draw_arc((X-D/2-PosX)*ZoomX, (Y-PosY)*ZoomY, (X+D/2-PosX)*ZoomX, (Y+D-PosY)*ZoomY, (X+Open-PosX)*ZoomX, (Y-PosY)*ZoomY, (Q1-PosX)*ZoomX, (Q2-PosY)*ZoomY)
  ).

